/** returned pointer can not be free'd */
static ___inline fpdbResultNodeCacheItem_t * _fpdbRNCacheGet(fpdbRNCache_t * cache, file_pt pt){
  fpdbResultNodeCacheItem_t * toRet = NULL;
  fpdbResultNodeCacheEntry_t * entry = NULL;
  if(cache == NULL){
    return NULL;
  }
  _FPRNC_LOCAL_CRITICAL_ENTER(cache);
  entry = (fpdbResultNodeCacheEntry_t *) ht_get(cache->fpdbResultNodeCache, &pt);
  if(entry != NULL){
    if(cache->lastCacheEntry != entry){
      /* set the entry to be the last */

      /* de-link the entry */
      if(entry->_nextCacheEntry != NULL){
        entry->_nextCacheEntry->_prevCacheEntry = entry->_prevCacheEntry;
      }else if(cache->lastCacheEntry == entry){ /* if there is no next, should be the last */
        cache->lastCacheEntry = entry->_prevCacheEntry;
      }
      if(entry->_prevCacheEntry != NULL){
        entry->_prevCacheEntry->_nextCacheEntry = entry->_nextCacheEntry;
      }else if(cache->firstCacheEntry == entry){/* if there is no prev, should be the first */
        cache->firstCacheEntry = entry->_nextCacheEntry;
      }

      /* re-link at the end */
      entry->_nextCacheEntry = NULL;
      entry->_prevCacheEntry = cache->lastCacheEntry;
      if(cache->lastCacheEntry != NULL){
        cache->lastCacheEntry->_nextCacheEntry = entry;
      }
      cache->lastCacheEntry = entry;
      if(cache->firstCacheEntry == NULL){
        cache->firstCacheEntry = entry;
      }
    }
    toRet = &(entry->sample);
    cache->cacheHit++;
  }else{
    cache->cacheMiss++;
  }
  _FPRNC_LOCAL_CRITICAL_LEAVE(cache);
  return toRet;
}

